//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "bad.h"
#include "utils.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm2 *Form2;
//---------------------------------------------------------------------------
__fastcall TForm2::TForm2(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm2::FormCreate(TObject *Sender)
{
PosForm(this, alRight);
}
//---------------------------------------------------------------------------
/*the following deliberatly causes a memory leak*/
void __fastcall TForm2::btnMemoryLeakClick(TObject *Sender)
{
TMemoryStream *mStream = NULL;  //see the notes on the use of NULL in the readme
TFileStream *fStream = NULL;    //however, because there's no try/finally handler
//the delete calls still aren't made.

mStream = new TMemoryStream;
//forgot, deliberatly, to do the fStream = new TFileStream(blah) !
mStream->CopyFrom(fStream, 0);  //thus this will cause an AV

if(mStream)
    delete mStream;

if(fStream)
    delete fStream;
}
//---------------------------------------------------------------------------
/*Allows for a deliberate access violation by giving the user the opportunity
to hit the button with nothing selected in the listbox*/
void __fastcall TForm2::btnBrokenListBoxClick(TObject *Sender)
{
this->Caption = ListBox1->Items->Strings[ListBox1->ItemIndex];
}
//---------------------------------------------------------------------------
/*Create a deliberate exception to tell them we want numbers only!*/
void __fastcall TForm2::btnNumbersOnlyClick(TObject *Sender)
{
try
    {
    StrToInt(Edit1->Text);
    this->Caption = Edit1->Text;
    }
catch(EConvertError &)
    {
    ShowMessage("We want numbers only thank you very much");
    }
catch(...)
    {
    throw;
    }
}
//---------------------------------------------------------------------------
/*Deliberatly throw a bad file*/
void __fastcall TForm2::btnDuffFileClick(TObject *Sender)
{
TFileStream *MyFile = NULL;
String fName;
char *Buffy = NULL;

if (Edit2->Text.IsEmpty())
    fName = GetParentFolder() + "testfile.txt";

MyFile = new TFileStream(fName, fmOpenReadWrite);
try
    {
    try
        {
        Buffy = new char[MyFile->Size + 1];
        MyFile->Read(Buffy, MyFile->Size);
        Buffy[MyFile->Size] = '\0';  //add null terminator
        this->Caption = Buffy;
        }
    __finally
        {
        if(Buffy)
            delete [] Buffy;
        }
    }
__finally
    {
    if(MyFile)
        delete MyFile;
    }
}
//---------------------------------------------------------------------------

