unit bad;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm2 = class(TForm)
    btnMemoryLeak: TButton;
    ListBox1: TListBox;
    btnBrokenListBox: TButton;
    btnNumbersOnly: TButton;
    Edit1: TEdit;
    btnDuffFile: TButton;
    Edit2: TEdit;
    procedure btnMemoryLeakClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnBrokenListBoxClick(Sender: TObject);
    procedure btnNumbersOnlyClick(Sender: TObject);
    procedure btnDuffFileClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

uses
  Utils;


procedure TForm2.FormCreate(Sender: TObject);
begin
  PosForm(Self, alRight);
end;

{creates a deliberate Memory Leak }

procedure TForm2.btnMemoryLeakClick(Sender: TObject);
var
  mStream :TMemoryStream;
  fStream :TFileStream;
begin

//mStream := nil; See notes on the use of NIL. Not needed here because the Free
//fStream := nil; and FreeAndNil calls are never made.

  mStream := TMemoryStream.Create;
  //forgot to do the fStream := TFileStream.Create(blah) !
  mStream.CopyFrom(fStream, 0); //thus this will cause an AV
  fStream.Free;
  FreeAndNil(mStream);
end;

{allows for a deliberate access violation by giving the user the opportunity to
hit the button with nothing selected in the ListBox}

procedure TForm2.btnBrokenListBoxClick(Sender: TObject);
begin

  with ListBox1 do begin
    Self.Caption := Items[ItemIndex];
  end;

end;

{create a deliberate exception to tell them we want numbers only!}

procedure TForm2.btnNumbersOnlyClick(Sender: TObject);
begin

  try
    StrToInt(Edit1.Text);
    Self.Caption := Edit1.Text;
  except
    on EConvertError do
      ShowMessage('We want numbers only thank you very much');
  else
    raise;
  end;

end;

procedure TForm2.btnDuffFileClick(Sender: TObject);
var
  MyFile :TFileStream;
  fName, s :String;
begin
  if (Length(Edit2.Text) = 0) then
    fName := GetParentFolder + 'testfile.txt';

  MyFile := TFileStream.Create(fName, fmOpenReadWrite);
  try
    SetLength(s, MyFile.Size);
    MyFile.Read(s[1], MyFile.Size);
    Self.Caption := s;
  finally
    FreeAndNil(MyFile);
    end;
end;


end.

